#include "pb_sdk.h"

bool
find_string(char *search)
{
 int slen;
 FILE *fp = fopen("MSGTMP","rt");
 if(!fp) return FALSE;

 slen = strlen(search);

 for(;;)
   {
    char s[100];
    int i,l;

    if(fgets(s,99,fp) == NULL) break;

    l = strlen(s);

    for(i=0;i<=l-slen;i++)
      if(!memicmp(&s[i],search,slen))
        {
         fclose(fp);
         return TRUE;
        }
   }

 fclose(fp);

 return FALSE;
}

void
showbusy()
{
 static int x = 0;
 static char s[] = "|\\-/";

 putchar('\b');
 putchar(s[x]);

 x = ++x % 4;
}


main(int argc,char *argv[])
{
 int i,result;
 MESSAGE msg;
 MSGAREA ma;
 char search[30];
 int area = CurUser->lastmsgarea;

 if(argc > 1) area = atoi(argv[1]);

 if(area)
   {
    if(ReadMsgArea(area,&ma)<0) return 0;
   }
 else
   {
    strcpy(ma.name,"Combined Boards");
   }

 printf("\n\f\n\6Text Search (\3%s\6)\n"
              "\7\n\n",ma.name);

 printf("\7Search string: \3");
 Input(search,29,INPUT_UPALL);

 if(search[0] == '\0') return 0;

 UnMarkAllMessages();

 printf("\n\n\7Press [\3S\7] to abort search. Searching for '\3%s\7'...\6  ",search);

 result = FirstMessage(&msg,area,1,1);

 for(i=0;result>=1;)
   {
    showbusy();

    CreateMessageText(&msg);

    if(toupper(PeekChar()) == 'S') break;

    if(find_string(search))
      {
       MarkMessage(msg.msgnum);

       i++;
      }

    result = NextMessage(&msg,area,1);
   }

 if(i)
   {
    char c;

    printf("\n\n\3%d \7messages with matching text found & marked.\n\n",i);

    for(;;)
      {
       printf("\7Action? \6[\3R\6]ead - [\3L\6]ist - [\3Q\6]uit\7 : ");

       c = WaitKeys("RLQ\r");

       putchar(c);
       putchar('\n');

       if(c == 'Q') break;
       if(c == 'R')
         {
          ReadMarkedMessages();
          break;
         }
       if(c == 'L')
         {
          ListMarkedMessages();
         }

       putchar('\n');
      }
   }
  else puts("\n\n\6No messages found. \7Press \3[Enter]\7 to continue.\t");

  return 0;
}


